<html>
	<head>
		<title>EDI processes</title>
    <!-- required viewer styles -->
    <link rel="stylesheet" href="https://unpkg.com/bpmn-js@9.1.0/dist/assets/bpmn-js.css">

    <!-- viewer distro (with pan and zoom) -->
    <script src="https://unpkg.com/bpmn-js@9.1.0/dist/bpmn-navigated-viewer.development.js"></script>

    <!-- needed for this example only -->
    <script src="https://unpkg.com/jquery@3.3.1/dist/jquery.js"></script>

		<!-- needed for showing markdown content-->
		<script src="https://cdn.jsdelivr.net/npm/marked/marked.min.js"></script>

    <!-- example styles -->
    <style>
      html, body {
				height: 100%;
        padding: 0;
        margin: 0;
			}

			#canvas {
				clear:both;
        height: 400px;
        padding: 0px 25px 25px 25px;
        margin: 0;
      }

			#documentation {
				font-family: Verdana, Geneva, sans-serif;
        font-size: 12px;
				border: 2px dashed white;
				width: 93%;
				padding: 10px 25px 25px 25px;
			}

			#documentation table {
				border-spacing : 0px
			}

			#documentation table thead {
				font-family: Verdana, Geneva, sans-serif;
        font-size: 12px;
				vertical-align: top;
				text-align: left;
				color: grey;
				padding : 5px 5px 5px 5px;
				border : 1px solid white;
			}

			#documentation table tr td {
				font-family: Verdana, Geneva, sans-serif;
        font-size: 12px;
				vertical-align: top;
				padding : 10px 10px 10px 10px;
				border : 1px solid white;
				background-color: #EEF;
			}

      .diagram-note {
        background-color: rgba(66, 180, 21, 0.7);
        color: White;
        border-radius: 5px;
        font-family: Arial;
        font-size: 12px;
        padding: 5px;
        min-height: 16px;
        width: 50px;
        text-align: center;
      }

      .current-focus:not(.djs-connection) .djs-visual > :nth-child(1) {
        stroke: rgba(66, 180, 21, 0.7) !important; /* color elements as red */
      }

      .djs-element {
      	cursor : pointer;
      }

			.topmenu {
				float:left;
				font-family: Verdana, Geneva, sans-serif;
        font-size: 12px;
				margin : 10px
			}

			.topmenu img {
				vertical-align: middle;
			}
			.topmenu select {
				vertical-align: middle;
			}

			.editmenu {
				float:right;
				clear:right;
				font-family: Verdana, Geneva, sans-serif;
        font-size: 12px;
				padding : 10px;
				background-color: grey;
				color : white;
				margin : 10px 20px 0px 0px;
			}

			.editmenu a {
				color : white;
				cursor : pointer;
			}

			.editmenu a:visited {
				color : white
			}

			div.story {
		    height: 326px;
		    padding: 15px 15px 0px 15px;
				margin: 0px 0px 25px 0px;
		    overflow: auto;
				width: 90%;
		    border: 1px solid #93afe3;
		    background-color: #e6ecfb;
			}

			img.story {
				 border:2px solid black
			}


    </style>
  </head>
  <body>
		<div class="topmenu">
			<!-- icon taken from https://www.reshot.com/free-svg-icons/item/home-GN6D7UFVMH/ -->
	    <a href="?p=toplevel"><img src="images/home.svg" alt="Home : go back to top level proces" width="50" height="50"></img></a>
			<img src="images/up.svg" alt="Up : go a level up" width="35" height="35" onclick="goUp()" style='cursor:pointer; margin: 0px 20px 0px 0px'></img>
			Use case: <select name="uc" onchange="switchToUseCase(this.value)" style='margin: 0px 20px 0px 0px'>
			<option value="EDI">EDI Generic</option>
			<option value="RDW">RDW offline drivers license check</option>
			<option value="DUO">DUO online proof of education</option>
		  </select>
			<a alt="Open issue list on gitlab (requires Gitlab Account)" href="https://gitlab.com/digicampus/ssi/edi/-/issues" target="issues">Open Issue List</a> | <a alt="Start a new issue on gitlab (requires Gitlab Account)" href="#" onclick="newIssue()">New Issue</a>
	  </div>
		<div class="editmenu"><a alt="Edit Documentation Text on gitlab (requires Gitlab Account)." onclick="editDocumentation()">Edit</a> | <a alt="copy link to current documentation page" onclick="copyLink()">Link</a></div>
		<div style="padding:5px;width:100%;clear:both"><div id="documentation"></div></div>
		<div class="editmenu"><a alt="Edit BPMN diagram source on gitlab (requires Gitlab Account)." onclick="editProcess()">Edit</a></div>
		<div id="canvas"></div>
    <script language="javascript">
      var params = new URLSearchParams(window.location.search);

			function getParam(paramName, defaultValue) {
				if(params.get(paramName) == null) {
					return defaultValue;
				}
				return params.get(paramName);
			}

			var p = getParam('p','toplevel');
			var uc = getParam('uc','EDI');
			var navstack = [];
			var pushToNavStack = '';

      var diagramUrl = uc+'/'+uc+'-'+p+'.bpmn?t='+Date.now();
			var documentationUrl = uc+'/'+uc+'-'+p+'.md?t='+Date.now();

      // viewer instance
      var bpmnViewer = new BpmnJS({
        container: '#canvas'
      });

      /**
       * Open diagram in our viewer instance.
       *
       * @param {String} bpmnXML diagram to display
       */
      async function openDiagram(bpmnXML) {

        // import diagram
        try {

					if(pushToNavStack != '') {
					  navstack.push(pushToNavStack);
						pushToNavStack = '';
					}

          await bpmnViewer.importXML(bpmnXML);

          // access viewer components
          var canvas = bpmnViewer.get('canvas');
          var overlays = bpmnViewer.get('overlays');


          // zoom to fit full viewport
          canvas.zoom('fit-viewport');

          // add marker
          //canvas.addMarker('SCAN_OK', 'needs-discussion');
        } catch (err) {

          console.error('could not import BPMN 2.0 diagram', err);
        }
      }

			function openItem(item) {
				var elementRegistry = bpmnViewer.get('elementRegistry');
				var canvas = bpmnViewer.get('canvas');
				var elem = elementRegistry.get(p);
				if(elem) {
					canvas.removeMarker(elem, 'current-focus');
				}
				p = item;
				diagramUrl = uc+'/'+uc+'-'+item+'.bpmn?t='+Date.now();
				documentationUrl = uc+'/'+uc+'-'+item+'.md?t='+Date.now();
				$.get(diagramUrl, openDiagram, 'text');
				$.get(documentationUrl, openDocumentation, 'text');
			}

			function switchToUseCase(usecase) {
				uc = usecase;
				openItem(p);
			}

			function goUp() {
				if(navstack.length > 0) {
						p = navstack.pop();
						pushToNavStack = '';
						switchToUseCase(uc);
				}
			}

			/**
			 * show documentation markdown.
			 *
			 * @param {String} md markdown to display
			 */
			async function openDocumentation(md) {
				oDiv = document.getElementById("documentation");
				oDiv.innerHTML = marked.parse(md);
				// access viewer components
				var elementRegistry = bpmnViewer.get('elementRegistry');
				var canvas = bpmnViewer.get('canvas');
				var elem = elementRegistry.get(p);
				// add marker
				if(elem) {
					canvas.addMarker(elem, 'current-focus');
				}
			}


      var eventBus = bpmnViewer.get('eventBus');

      // you may hook into any of the following events
      var events = [
       'element.click'
      ];

      events.forEach(function(event) {
        eventBus.on(event, function(e) {
					  console.log(e.element.id);
						pushToNavStack = p;
					  openItem(e.element.id);
        });
      });

			function editDocumentation() {
				window.open('https://gitlab.com/-/ide/project/digicampus/ssi/edi/edit/main/-/public/'+uc+'/'+uc+'-'+p+'.md', 'editor');
			}

			function editProcess() {
				window.open('https://gitlab.com/-/ide/project/digicampus/ssi/edi/edit/main/-/public/'+uc+'/'+uc+'-'+p+'.bpmn', 'editor');
			}

			function newIssue() {
				window.open('https://gitlab.com/digicampus/ssi/edi/-/issues/new?issue[title]=Suggestion+for+'+encodeURI(uc)+'/'+encodeURI(uc)+'-'+encodeURI(p)+'&issue[description]=type+your+suggestion+here...','newissue'+Date.now());
			}

			function copyLink() {
				window.open('?p='+p+'&uc='+uc);
			}

      // load external diagram file via AJAX and open it
      $.get(diagramUrl, openDiagram, 'text');
			$.get(documentationUrl, openDocumentation, 'text');
    </script>
  </body>
</html>
